	
	include "doorsos.h"
	include "graphlib.h"
	include "filelib.h"
	include "userlib.h"
	include "ziplib.h"
	xdef		_ti92plus
	xdef		_ti89
 	xdef 		_main
;---------------------------------------------------------------------

_main:
	bra.s	after

handle	dc.w	0

after
	move.w	handle(pc),d7
	tst.w	d7
	bne	\cont
	rts		; bye bye
\cont
;-----------C y est on a l'handle de l'EXPR dans d7--------------------

	move.l		doorsos::top_estack,d3	; sauve l'estack
	move.l		a7,a6
	move.w		#$300,-(a7)			;le flag de la window
	pea		rect(Pc)			;taille de la window
	push.l		#window			;endroit o on va storer la window
	jsr    	doorsos::WinOpen
	tst.b		d0
	beq		\w_err

	push.l		#window
	jsr		doorsos::WinClr

	move.w   	d7,-(a7)			; l'EXPR maintenant !
	jsr    	doorsos::HToESI		;gnre l'ESI
	move.l		a0,a2
	push.b		(a0)				; pushes *ESI
	jsr		doorsos::QSysProtected
	tst.w		d0
	bne		\quit

	clr.w		-(a7)
	move.l		a2,-(a7)			
	jsr    	doorsos::Parse2DExpr		;construit l'image
	move.l		a0,a2				; sauve le resultat ed parse2d
	pea		bottom(pc)
	pea		top(pc)
	pea		width(pc)
	push.l		a2
	jsr		doorsos::Parms2D

	move.w		bottom,d0
	add.w		top,d0
	push.w		d0
	clr.w		-(a7)
	push.l		#window
	push.l		a2
	jsr    	doorsos::Print2DExpr		;affiche en PrettyPrint
	jsr		userlib::idle_loop

\quit
	push.l		#window
	jsr		doorsos::WinClose
\w_err	move.l		a6,a7
	move.l		d3,doorsos::top_estack
	rts

;void Parms2D(ESI display_data,short *width,short *top,short *bottom);
;Print2DExpr(ESI display_data,WINDOW *window,short x,short y);

rect		dc.w		0,0,LCD_WIDTH,LCD_HEIGHT-8
width		dc.w		0
top		dc.w		0
bottom		dc.w		0

	BSS		; uninitialized data

window		ds.l		60

	rts
	end